unit UPub;

interface

uses
  Windows, SysUtils, Classes,Graphics,Messages, Forms, DB ,Dialogs, Controls,DBGrids,
  Grids,dbctrls,stdctrls,variants,IniFiles,dateutils,typinfo,comobj,shellapi
  ,comctrls,clipbrd,winsock;

type
  TSQLConfigDataSource = function( hwndParent: HWND;
                                   fRequest: WORD;
                                   lpszDriver: LPCSTR;
                                   lpszAttributes: LPCSTR ) : BOOL; stdcall;

  RowNumber = CLASS(TCustomDBGrid);
    tgd=class(tcustomdbgrid)
    private
    protected
    public
      obj:twincontrol;
      fieldname:string;
      fmysender:twincontrol;
      factivefield:tfield;
      freturnfield:tfield;
      procedure DrawDataCell( const Rect: TRect;
        Field: TField; State: TGridDrawState);
      property row;
      property rowheights;
    end;

   tsysdata=class(TPersistent)
   private
     fexepath:string;
     fcompanyid:string;
     procedure setcompanyid(value:string);
   public
     constructor create(aowner:tobject);
   published
     property exepath :string read fexepath write fexepath;
     property companyid:string read fcompanyid write setcompanyid;
   end;
function hasprop(obj:tobject;str:string):boolean;
function MyConfirmation(MyMessage : String): Boolean;
procedure MyWarning(MyMessage : String);
procedure MyError(MyMessage: String);
procedure OpenForm(FormClass: TFormClass; var fm; AOwner:TComponent);
procedure CreateChildForm(FormName: string;isbig:boolean=true);
function openmodalFormbyname(formname:string;owner:tcomponent):boolean;
procedure openFormbyname(formname:string);
procedure closeFormbyname(formname:string);
function ExecuteForm(AFormClass: TFormClass): Boolean;
//procedure setlabel(ctl:twincontrol;dt:tdataset);
function getexepath:string;

function readinistring(f:string;a:string;b:string):string;
procedure writeinistring(f:string;a:string;b:string;c:string);

function RightStr(cString: String; cR: Integer): String;
function SubStr(cString: String; cB: Integer; cE: Integer): String;
function LeftStr(cString: String; cL: Integer): String;
function datetostrx(da:tdatetime):string;
function getctlbyfield(fm:tform;fieldname:string):tobject;

procedure doloading;
procedure stoploading;
procedure dosave;
procedure stopsave;
procedure doprogress;
procedure stopprogress;
procedure doprocess;
procedure stopprocess;

procedure DBGrid2Excel(DBGrid:TDBGrid;ExcelFileName:string);
procedure showdt(dt:tdataset;owner:tcomponent);
function getdate:tdate;

function createodbc(dbname:string;dsn:string;driver:string):boolean;
procedure XDrawDataCell(sender:tobject;const Rect: TRect;Field: TField; State: TGridDrawState);
procedure genctl(dt:tdataset;pr:twincontrol);
procedure gengd(dt:tdataset;pr:twincontrol);
function getsysh:integer;
function getsysw:integer;

function GetIP(Name:string) : string;
function GetIP2 : string;

function SQLConfigDataSource(hwndParent: HWND;    fRequest: Word;    lpszDriver: PChar;    lpszAttributes: PChar): boolean; stdcall;    external 'ODBCCP32.DLL';
procedure SetupODBC(s:string);
function getfiletime(sfile:string):tdatetime;
function getfiledate(sfile:string):tdate;

var exepath,inifile:string;
var gserver,guserid,gusername,gdatapath,greportpath,gcompanyid,gcompanyname:string;
var gcanpass:integer;//Юv
var osys:tsysdata;
var gsmallfont:boolean;

const
  ODBC_ADD_DSN        = 1;    // Add data source
  ODBC_CONFIG_DSN     = 2;    // Configure (edit) data source
  ODBC_REMOVE_DSN     = 3;    // Remove data source
  ODBC_ADD_SYS_DSN    = 4;    // add a system DSN
  ODBC_CONFIG_SYS_DSN = 5;    // Configure a system DSN
  ODBC_REMOVE_SYS_DSN = 6;    // remove a system DSN

implementation

uses ufmquerygrid, ufmcalendar;

procedure SetupODBC(s:string);
var Driver,Attributes:string;
begin   // إߤ@ ODBC_NAME V Accessc:\test.mdb
    Driver := 'firebird/interbase(r) driver';
    Attributes := 'DSN=f;' + 'dbname='+s+';user=sysdba;password=masterkey';
    if SQLConfigDataSource(0, 4, PChar(Driver), PChar(Attributes))
    then
       showmessage('Ʈw]w\')
    else
       showmessage('Ʈw]w');

end;



function getsysh:integer;
var
    dc:hdc;
    SysMetrics, Metrics: TTextMetric;
begin
  DC := GetDC(0);
  GetTextMetrics(DC, SysMetrics);
  result:=sysmetrics.tmHeight+10;

end;
function getsysw:integer;
var
    dc:hdc;
    SysMetrics, Metrics: TTextMetric;
begin
  DC := GetDC(0);
  GetTextMetrics(DC, SysMetrics);
  result:=sysmetrics.tmAveCharWidth;
end;

procedure genctl(dt:tdataset;pr:twincontrol);
var i,j,iw,ih,mxlen:integer;
    owner:tcomponent;
    lb:tlabel;
    ed:tdbedit;
    rh:tdbrichedit;
    p:tpoint;
const offset=10;
begin
    owner:=pr.Owner;
    tform(owner).AutoScroll:=true;
    iw:=pr.Width;ih:=pr.Height;
    p.x:=10;
    p.y:=10;
    mxlen:=0;

     for i:=0 to dt.FieldCount -1 do begin


        lb:=tlabel.Create(owner);
        lb.Name:='syslb'+inttostr(i);
        lb.Parent:=pr;
        lb.AutoSize:=true;
        lb.Caption:=dt.Fields[i].DisplayLabel;
        lb.Alignment:=taLeftJustify;

        if lb.width > mxlen then  begin
           mxlen:=lb.width;
        end;

        lb.Left:=10;
        lb.Top:=p.y;
     end;

     for i:=0 to dt.fieldcount-1 do begin
         tlabel(owner.findcomponent('syslb'+inttostr(i))).AutoSize:=false;
         tlabel(owner.FindComponent('syslb'+inttostr(i))).Width:=mxlen;
     end;

     for i:=0 to dt.fieldcount -1 do begin
         if dt.fields[i].DataType=ftmemo then begin
            rh:=tdbrichedit.Create(owner);
            rh.parent:=pr;
            for j:=0 to owner.ComponentCount-1 do begin
              if owner.Components[j] is tdatasource then begin
                 if tdatasource(owner.Components[j]).dataset = dt then
                 begin
                   rh.DataSource:=tdatasource(owner.Components[j]);
                 end;
              end;
            end;
            rh.DataField:=dt.Fields[i].FieldName;
            rh.Left:=lb.Left+lb.Width+10;
            rh.Top:=p.y;
            rh.Width:=pr.clientwidth-rh.left-10;
            p.y:=rh.top+rh.height+10;
            tlabel(owner.findcomponent('syslb'+inttostr(i))).Top:=rh.Top;
         end
         else begin
           ed:=tdbedit.Create(owner);
           ed.Parent:=pr;
           for j:=0 to owner.ComponentCount-1 do begin
             if owner.Components[j] is tdatasource then begin
                if tdatasource(owner.Components[j]).dataset = dt then
                begin
                  ed.DataSource:=tdatasource(owner.Components[j]);
                end;
             end;
           end;
           ed.DataField:=dt.Fields[i].FieldName;
           ed.Left:=lb.Left+lb.Width+10;
           ed.Top:=p.y;
           ed.Width:=dt.fields[i].DisplayWidth*getsysw;
           if ed.Left+ed.width > pr.ClientWidth then begin
              ed.Width:=pr.clientwidth-ed.left-10;
           end;
           p.Y:=ed.Top+ed.Height+10;
           tlabel(owner.findcomponent('syslb'+inttostr(i))).Top:=ed.Top;
         end;
     end;

     //tform(pr).Font.size:=10;
end;

function createodbc(dbname:string;dsn:string;driver:string):boolean;
var
  pFn: TSQLConfigDataSource;
  hLib: LongWord;
  strDriver: string;
  strAttr: string;
  strFile: string;
  fResult: BOOL;
  srInfo : TSearchRec;
begin
  result:=false;
  strFile := dbname;
  hLib := LoadLibrary( 'ODBCCP32' );
  
  if( hLib <> NULL ) then
  begin
    @pFn := GetProcAddress( hLib, 'SQLConfigDataSource' );
    if( @pFn <> nil ) then
    begin
      // force (re-)create DSN
      if driver='firebird' then begin
        strDriver := 'firebird/interbase(r) driver';
        strAttr := Format( 'DSN=%s'+#0+
                           'driver=%s;'+#0+
                           'database=%s;'+#0+
                           'database account=%s;'+#0+
                           'password=%s;'+#0,
                           [dsn,strdriver,'c:\lj.gdb','sysdba','masterkey'] );
        fResult := pFn( 0, ODBC_ADD_SYS_DSN, @strDriver[1], @strAttr[1] );
      end;
      if driver='access' then begin
        strDriver := 'microsoft access driver (*.mdb)';
        strAttr := Format( 'DSN=%s'+#0+
                           'driver=%s;'+#0+
                           'dbq=%s;'+#0,
                           [dsn,strdriver,dbname] );
        fResult := pFn( 0, ODBC_ADD_SYS_DSN, @strDriver[1], @strAttr[1] );
      end;
    end;
    FreeLibrary( hLib );
    result:=fresult; 
  end;
end;

function getdate:tdate;
begin
     result:=ufmcalendar.showme; 
end;

procedure showdt(dt:tdataset;owner:tcomponent);
begin
    ufmquerygrid.showme(dt);
end;
procedure printdt(dt:tdataset);
begin

end;

function getctlbyfield(fm:tform;fieldname:string):tobject;
var i:integer;
begin
    result:=nil;
    fieldname:=uppercase(fieldname);
    for i:= 0 to fm.Componentcount -1 do begin
        if hasprop(fm.components[i],'datasource') then begin
           if uppercase(typinfo.GetPropValue(fm.components[i],'datafield'))=fieldname then begin
              result:=fm.components[i];
           end;
        end;
    end;

end;

function MyConfirmation(MyMessage : String): Boolean;
begin
  if MessageDlg(MyMessage, mtConfirmation, [mbOk, mbCancel], 0) = mrOk then
    MyConfirmation := True
  else
    MyConfirmation := False;
end;
procedure MyWarning(MyMessage : String);
begin
  MessageDlg(MyMessage, mtWarning, [mbOk], 0);
end;
procedure MyError(MyMessage: String);
begin
  MessageDlg(MyMessage, mtError, [mbOk], 0);
end;

procedure OpenForm(FormClass: TFormClass; var fm; AOwner:TComponent);
var
  i: integer;
  Child:TForm;
begin
  for i := 0 to Screen.FormCount -1 do  begin
    if Screen.Forms[i].ClassType = FormClass then begin
        Child:=Screen.Forms[i];
        if Child.WindowState=wsMinimized then
           ShowWindow(Child.handle,SW_SHOWNORMAL)
        else
           ShowWindow(Child.handle,SW_SHOWNA);
        if (not Child.Visible) then Child.Visible:=True;
        Child.BringToFront;
        Child.Setfocus;
        child.WindowState:=wsmaximized;
        TForm(fm):=Child;
        exit;
    end;
  end;
  Child:=TForm(FormClass.NewInstance);
  child.WindowState:=wsnormal;
  TForm(fm):=Child;
  Child.Create(AOwner);
end;

procedure openFormbyname(formname:string);
var
  i: integer;
  Child:TForm;
begin
   for i := 0 to Screen.FormCount -1 do  begin
    if uppercase(Screen.Forms[i].classname) = uppercase(Formname) then begin
        Child:=Screen.Forms[i];
        if Child.WindowState=wsMinimized then
           ShowWindow(Child.handle,SW_SHOWNORMAL)
        else
           ShowWindow(Child.handle,SW_SHOWNA);
        if (not Child.Visible) then Child.Visible:=True;
        Child.BringToFront;
        child.Update;
        exit;
     end;
   end;
   Child:=TFormClass(FindClass(FormName)).Create(Application);
   child.show;
   child.Update;
   child.BringToFront;

end;

procedure closeFormbyname(formname:string);
var
  i: integer;
  Child:TForm;
begin
   for i := 0 to Screen.FormCount -1 do  begin
    if uppercase(Screen.Forms[i].classname) = uppercase(Formname) then begin
        Child:=Screen.Forms[i];
        if Child.WindowState=wsMinimized then
           ShowWindow(Child.handle,SW_SHOWNORMAL)
        else
           ShowWindow(Child.handle,SW_SHOWNA);
        if (not Child.Visible) then Child.Visible:=True;
        child.Close;
        child.Free;
        exit;
     end;
   end;
end;

procedure CreateChildForm(FormName: string;isbig:boolean=true);
var
  ICont: Integer;
  Form: TForm;
begin
  Form := nil;
  for icont:=0 to application.MainForm.MDIChildCount -1 do begin
    if uppercase(application.MainForm.MDIChildren[icont].ClassName)
       = uppercase(FormName) then
    begin
      Form := application.MainForm.MDIChildren[ICont];
      Form.BringToFront;
      if isbig then
         Form.WindowState := wsMaximized;
      exit;
    end;
  end;
  if Form = nil then
  begin
    Form := TFormClass(FindClass(FormName)).Create(Application);
  end;
  if isbig then
     Form.WindowState := wsMaximized;
end;

function ExecuteForm(AFormClass: TFormClass): Boolean;
begin
  Screen.Cursor:= crHourGlass;
  with AFormClass.Create(Application) do begin
    //formstyle:=fsstayontop;
    update;
    Screen.Cursor:= crDefault;
    if ShowModal = mrOK then
      Result := True
    else
      Result := False;
    Free;
  end;
end;

{procedure setlabel(ctl:twincontrol;dt:tdataset);
var i,j:integer;
    lb:tlabel;
begin
      for i:=0 to ctl.Componentcount-1 do
      begin
         if ctl.components[i] is tlabel then begin
            lb:=tlabel(ctl.components[i]);
            if (lb.FocusControl<> nil) and
               (lb.FocusControl is tdbedit)
            then begin
                lb.AutoSize:=false;
                lb.Caption:=tdbedit(lb.FocusControl).Field.DisplayLabel;
            end;
         end;
      end;
end;}
function getexepath:string;
var str:string;
begin
        str:=application.ExeName;
        result:=extractfilepath(str);
end;
function readinistring(f:string;a:string;b:string):string;
var i:tinifile;
begin
    i:=tinifile.Create(f);
    try
      result:=i.ReadString(a,b,'');
    except
      result:='';
    end;
    i.free;
end;
procedure writeinistring(f:string;a:string;b:string;c:string);
var i:tinifile;
begin
    i:=tinifile.Create(f);
    try
      i.WriteString(a,b,c);
    except
    end;
    i.free;
end;

function SubStr(cString: String; cB: Integer; cE: Integer): String;
var
  ms : String;
  ml, mb, me : Integer;
begin
  ms := cString;
  ml := Length(cString);
  mb := cB;
  me := cE;
  if mb > ml then mb := ml;
  if me > (ml - mb + 1) then me := (ml - mb + 1);
  SubStr := Copy(ms, mb, me);
end;

function LeftStr(cString: String; cL: Integer): String;
var
  ms : String;
  ml, mh, mb, me : Integer;
begin
  ms := cString;
  ml := Length(cString);
  mh := cL;
  if mh > ml then mh := ml;
  mb := 1;
  me := mh;
  LeftStr := Copy(ms, mb, me);
end;

function RightStr(cString: String; cR: Integer): String;
var
  ms : String;
  ml, mh, mb, me : Integer;
begin
  ms := cString;
  ml := Length(cString);
  mh := cR;
  if mh > ml then mh := ml;
  mb := ml - mh + 1;
  me := mh;
  RightStr := Copy(ms, mb, me);
end;
function datetostrx(da:tdatetime):string;
var y,m,d:string;
begin
     y:=inttostr(yearof(da)-1911);
     m:=inttostr(monthof(da));
     d:=inttostr(dayof(da));
     if length(m)=1 then m:='0'+m;
     if length(d)=1 then d:='0'+d;
     result:=y+m+d;
end;
function openmodalFormbyname(formname:string;owner:tcomponent):boolean;
var
  i: integer;
  Child:TForm;
begin
     Child:=TFormClass(FindClass(FormName)).Create(owner);
     if child.FormStyle=fsmdichild then begin
        child.formstyle:=fsnormal;
        child.Visible:=false;
     end;
     child.Position:=poScreenCenter;
     child.Update;
     if child.ShowModal = mrOK then
        Result := True
     else
      Result := False;
     child.free;
end;

procedure doloading;
begin
   openformbyname('tfmloading');
end;
procedure stoploading;
begin
   closeformbyname('tfmloading');
end;
procedure dosave;
begin
   openformbyname('tfmprocess');
end;
procedure stopsave;
begin
   closeformbyname('tfmprocess');
end;
procedure doprogress;
begin
    openformbyname('tfmprogress');
end;
procedure stopprogress;
begin
    closeformbyname('tfmprogress');
end;
procedure doprocess;
begin
    openformbyname('tfmprocess');
end;
procedure stopprocess;
begin
    closeformbyname('tfmprocess');
end;

{ sysdata }

constructor tsysdata.create(aowner: tobject);
var s:string;
begin
end;

procedure tsysdata.setcompanyid(value: string);
begin
      if value <> self.fcompanyid then
         self.fcompanyid:=value;
end;
function hasprop(obj:tobject;str:string):boolean;
begin
    try
        typinfo.GetObjectProp(obj,str);
          result:=true;
    except
      result:=false;
    end;
end;

procedure DBGrid2Excel(DBGrid:TDBGrid;ExcelFileName:string);
var  MyExcel: Variant;
     x,y:integer;
begin
  deletefile(ExcelFileName);
  MyExcel := CreateOleOBject('Excel.Application');
  // o@q|sudaץ
  MyExcel.WorkBooks.Add;
  MyExcel.Visible := True;
  MyExcel.WorkBooks[1].Saveas(ExcelFileName);
  dbgrid.DataSource.DataSet.First;

  y:=1;
  for x:=1 to dbgrid.FieldCount do
  begin
    MyExcel.WorkBooks[1].WorkSheets[1].Cells[y,x] := dbgrid.Fields[x-1].DisplayName;
    // N]п
    MyExcel.WorkBooks[1].WorkSheets[1].Cells[y,x].Select;
    // NDܲr
    MyExcel.Selection.Font.Bold := true;
    // ]we
    MyExcel.WorkBooks[1].WorkSheets[1].Columns[x].ColumnWidth := dbgrid.Fields[x-1].DisplayWidth;
  end;
  inc(y);
  while not dbgrid.DataSource.DataSet.eof do
  begin
    for x:=1 to dbgrid.FieldCount do
    begin
       MyExcel.WorkBooks[1].WorkSheets[1].Cells[y,x] := dbgrid.Fields[x-1].AsString;
    end;
    inc(y);
    dbgrid.DataSource.DataSet.next;
  end;
end;


{ tgd }

procedure tgd.DrawDataCell(const Rect: TRect; Field: TField;
  State: TGridDrawState);
var i:integer;
begin
  inherited;
  with self do
  begin
    with RowNumber(self) do begin
      if (Odd(DataLink.ActiveRecord))
        then begin
        Canvas.Brush.Color := $00FFEBDF;
        canvas.Font.color:=clblack;
        DefaultDrawDataCell(Rect, Field, State);
      end;
      if (state=[gdselected]) then begin
        Canvas.Brush.Color := clblue;
        canvas.Font.color:=clwhite;
        DefaultDrawDataCell(Rect, Field, State);
      end;
    end;
  end;
end;


procedure XDrawDataCell(sender:tobject;const Rect: TRect; Field: TField;
  State: TGridDrawState);
var i:integer;
begin
  with tdbgrid(sender) do
  begin
    with RowNumber(sender) do begin
      if (Odd(DataLink.ActiveRecord))
        then begin
        Canvas.Brush.Color := $00FFEBDF;
        canvas.Font.color:=clblack;
        DefaultDrawDataCell(Rect, Field, State);
      end;
      if (state=[gdselected]) then begin
        Canvas.Brush.Color := clblue;
        canvas.Font.color:=clwhite;
        DefaultDrawDataCell(Rect, Field, State);
      end;
    end;
  end;
end;
procedure gengd(dt:tdataset;pr:twincontrol);
var i,j,iw,ih,mxlen:integer;
    owner:tcomponent;
    gd:tdbgrid;
    ds:tdatasource;
begin
    owner:=pr.Owner;
    iw:=pr.Width;ih:=pr.Height;
    gd:=tdbgrid.Create(owner);
    gd.Align:=alclient;
    gd.Parent:=pr;
    ds:=tdatasource.Create(owner);
    gd.DataSource:=ds;
    ds.dataset:=dt;

end;
function GetIP(Name:string) : string;
type TaPInAddr = array [0..10] of PInAddr;
     PaPInAddr = ^TaPInAddr;
var  phe :PHostEnt;
     pptr : PaPInAddr;
     I : Integer;
     GInitData : TWSADATA;
     wVersionRequested:word;
begin

  //wVersionRequested := MAKEWORD( 2, 0 );

  WSAStartup($101, GInitData);
  WSAStartup(wVersionRequested, GInitData);
  Result := '';

  phe :=GetHostByName(pchar(Name));
  pptr := PaPInAddr(Phe^.h_addr_list);
  result:=StrPas(inet_ntoa(pptr^[0]^));
  WSACleanup;
end;

function GetIP2 : string;
type
TaPInAddr = array [0..10] of PInAddr;
PaPInAddr = ^TaPInAddr;
var
phe : PHostEnt;
pptr : PaPInAddr;
Buffer : array [0..63] of char;
I : Integer;
GInitData : TWSADATA;
begin
WSAStartup($101, GInitData);
Result := '';
GetHostName(Buffer, SizeOf(Buffer));
phe :=GetHostByName(buffer);
if phe = nil then Exit;
pptr := PaPInAddr(Phe^.h_addr_list);
I := 0;
while pptr^[I] <> nil do begin
result:=StrPas(inet_ntoa(pptr^[I]^));
Inc(I);
end;
WSACleanup;
end;

function getfiletime(sfile:string):tdatetime;
var i,j:integer;
    fstruct:tofstruct;
begin
    i:=openfile(pchar(sfile),fstruct,OF_SHARE_DENY_NONE);
    j:=filegetdate(i);
    result:=filedatetodatetime(j);
end;
function getfiledate(sfile:string):tdate;
var i,j:integer;
    fstruct:tofstruct;
begin
    i:=openfile(pchar(sfile),fstruct,OF_SHARE_DENY_NONE);
    j:=filegetdate(i);
    result:=filedatetodatetime(j);
end;

end.

